/* global require, module, __dirname */
'use strict';
const path = require('path');

module.exports = {
  entry:  './main.js',
  output: {
    path: path.resolve(__dirname),
    filename: './dist/main.bundle.js'
  },
  module: {
    preloader: [
      { test: /\.js$/, loader: 'eslint-loader', exclude: /node_modules/ }
    ],
    loaders: [
      { test: /\.js$/,
        loaders: [
          'babel-loader?presets=es2015',
          __dirname + '/../../tools/jsx-loader.js'
        ],
        exclude: /node_modules/
      }, {
      test: /\.css?$/,
      loaders: [ 'style', 'raw' ],
      include: __dirname
    }
    ]
  },
  plugins: [
  ],
  stats: {
    colors: true
  },
  devtool: 'source-map',
  eslint: {
    configFile: '.eslintrc.js',
    fix: true,
    plugins: [
      'react'
    ]
  }
};
