# redom
A kind of experimental UI library.
It was made to find a way to have real DOM library that allows writing beautiful code.
Currently it is far for beautiful. It is not even nice.

## what is included
* createComponent function to (guess what?) create components
* jsx loader module to compile jsx to JS
* simple event emitter
* example todo application

## useful features (if any ;) )
* gather references for DOM nodes?

## how to use
First create component using:
``` javascript
component = createComponent(methods, boundMethods)
```

Example:

``` javascript
const myComponent = createComponent({
  create(label) {
    // Do some initialization.
    this.label = label;
  },
  view(str) {
    return <label>Click <button ref="btn">{str}</button></label>
  },
  render(container) {
    const {node, r} = this.view(this.label);
    this.refs = r;
    r.btn.addEventListener('click', this.onClick);
    container.appendChild(node);
  }
}, {
  onClick(e) {
    this.refs.btn.innerHTML += '!';
    this.trigger('clicked', this.label);
  }
}

const container = document.getElementById('container');
const first = myComponent('me!');
first.render(container);
first.on('clicked', (lbl) => console.log(lbl));

```
Basicly ```createComponent``` will return factory function that will create component instances. Parameters passed to factory function will be passed to component ```create``` method.

Component instance is EventEmitter.

```boundMethods``` are bound to component instance.

The idea is to render component (DOM) once, and then work using references.

The code propably still does not have much comments, but is small enough to be read in 3 minutes :)

## the plan
* make it beautiful
* make it usable

## license
MIT